SystemOrganization addCategory: #KEGStreamUtilityStuff!

!ReadStream methodsFor: '*KEGStreamUtilityStuff' stamp: 'KjellGodo 4/10/2013 20:22'!
"(| defineMethod-:(" contentsKEG ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030201
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030201
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#contentsKEG s:self )."
	^(
		( ( self size ) = ( collection size )
		)  ifTrue:[ collection ]
		   ifFalse:[ self contents ]

	)"return:( 					MT e:#contentsKEG s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the contents of self.

 )-summary
 methodDescriptionDetail-:(

	If we can avoid the copy of the collection self is on then we do by just
	returning the collection.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!WriteStream methodsFor: '*KEGStreamUtilityStuff' stamp: 'KjellGodo 4/11/2013 18:09'!
"(| defineMethod-:(" contentsKEG ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20021008
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20021008
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>
	)-notes methodBody-:(
 (| let-:("| oldPos |")
    letBody-:("					"( MT b:#contentsKEG s:self )."
	( oldPos := self position ).
	^(
		( ( self setToEnd ; size ) = writeLimit )
			ifTrue:[   ( self position: oldPos ).( collection ) ]
			ifFalse:[ ( self position: oldPos ).( self contents ) ]

	)"return:( 					MT e:#contentsKEG s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the collection of self without copying if it's size is equal to the size of self.
	Sometimes we can get away without copying if we know there won't be any mutations.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... ) )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !
